ServerEvents.tags('item', e => {
  //Tag Add
  e.add('upgrade_aquatic:driftwood_logs', 'aquaculture:driftwood')
  e.add('forge:tools/hammers', ['/.+_hammer/', 'mcwwindows:hammer'])
  e.add('forge:corals', [/\w+:(?!dead)(\w+)_coral$/])
  e.add('forge:coral_blocks', [/\w+:(?!dead)(\w+)_coral_block$/])
  e.add('forge:coral_fans', [/\w+:(?!dead)(\w+)_coral_fan$/])
  e.add('forge:dead_corals', [/dead_\w+coral$/])
  e.add('forge:dead_coral_blocks', [/dead_\w+coral_block$/])
  e.add('forge:dead_coral_fans', [/dead_\w+coral_fan$/])
  e.add('forge:furnace', [/minecraft:.+_furnace/, 'jumbofurnace:jumbo_furnace', /engineersdecor:small_.+_furnace/, /ironfurnaces:.+_furnace/, 'ironfurnaces:item_spooky', 'ironfurnaces:item_xmas'])
  e.add('forge:hopper', ['/.+_hopper/', '/.+:hopper_.+/', 'minecraft:hopper'])
  e.add('forge:chunks/coal', 'ironcoals:base_coal_chunk')
  e.add('forge:piston', ['minecraft:sticky_piston', 'minecraft:piston', 'multipiston:multipistonblock'])
  e.add('forge:eyes', ['minecraft:ender_eye', 'reliquary:salamander_eye', 'alexsmobs:guster_eye', 'alexsmobs:void_worm_eye', 'upgrade_aquatic:elder_eye'])
  e.add('forge:cauldron', ['minecraft:cauldron', 'reliquary:apothecary_cauldron'])
  e.add('forge:chains', ['minecraft:chain', 'decorative_blocks:chain', /additionallanterns:.+_chain/,])
  e.add('forge:clock', ['minecraft:clock', 'supplementaries:clock_block'])

  //Tag Get
  e.get('forge:workbenches').add(['minecraft:crafting_table', /blue_skies:\w+_crafting_table/]);
  e.get('forge:workbench').add(['minecraft:crafting_table', /blue_skies:\w+_crafting_table/]);
  e.get('forge:mushroom_caps').add(['undergarden:blood_mushroom_cap', 'undergarden:ink_mushroom_cap', 'undergarden:veil_mushroom_cap', 'undergarden:indigo_mushroom_cap']);
  e.get('forge:mushroom_colonies/brown').add(['aquaculture:brown_shrooma']);
  e.get('forge:mushroom_colonies/red').add(['aquaculture:red_shrooma']);
  e.get('forge:netherbricks/red').add([/rechiseled:red_nether_bricks/]);
  e.get('forge:netherrack').add(['quark:netherrack_bricks', /rechiseled:netherrack_/]);
  e.get('forge:sandstone/red').add([/rechiseled:red_sandstone/]);
  e.get('forge:sandstone/colorless').add([/rechiseled:sandstone_/]);
  e.get('forge:end_stones').add([/rechiseled:end_stone/]);
  e.get('forge:cobblestone').add([/rechiseled:cobblestone_/]);
  e.get('chiselsandbits:chisel').add(['rechiseled:chisel']);
  e.get('forge:stone').add(['graveyard:tg_deepslate']);
  e.get('minecraft:stone_tool_materials').add(['#forge:stone', '#forge:cobblestone']);
  e.get('minecraft:stone_crafting_materials').add(['#forge:stone', '#forge:cobblestone']);
  e.get('forge:storage_blocks/glowstone').add([/rechiseled:glowstone_/, /chipped:glowstone_/]);
  e.get('chipped:diorite').add([/rechiseled:diorite_/]);
  e.get('chipped:glowstone').add([/rechiseled:glowstone_/]);
  e.get('chipped:obsidian').add([/rechiseled:obsidian_/]);
  e.get('chipped:andesite').add([/rechiseled:andesite_/]);
  e.get('forge:obsidian').add([/rechiseled:obsidian_/]);
  e.get('forge:beach_grass').add(['upgrade_aquatic:beachgrass']);
  e.get('forge:blocks/quartz').add([/rechiseled:quartz_block/, /chipped:quartz_block/]);
  e.get('forge:bricks/nether').add([/rechiseled:nether_bricks/, /chipped:nether_bricks/]);
  e.get('minecraft:beds').add(['undergarden:depthrock_bed']);
  e.get('forge:tools/sword').add(['/.+_sword/', '/.+:sword_.+/']);
  e.get('forge:tools/swords').add(['/.+_sword/', '/.+:sword_.+/']);
  e.get('forge:tools/hoe').add(['/.+_hoe/', '/.+:hoe_.+/']);
  e.get('forge:tools/hoes').add(['/.+_hoe/', '/.+:hoe_.+/']);
  e.get('forge:tools/shovel').add(['/.+_shovel/', '/.+_paxel/', '/.+:shovel_.+/']);
  e.get('forge:tools/shovels').add(['/.+_shovel/', '/.+_paxel/', '/.+:shovel_.+/']);
  e.get('forge:tools/pickaxe').add(['/.+_pickaxe/', '/.+_paxel/']);
  e.get('forge:tools/pickaxes').add(['/.+_pickaxe/', '/.+_paxel/']);

  //#endregion

  //#region REMOVALS
  e.remove('forge:string', 'undergarden:twistytwig')
  e.remove('forge:tools/pickaxes', 'apotheosis:pickaxe_tome')
  //#endregion
})